const Lang = imports.lang;
const St = imports.gi.St;
const Cinnamon = imports.gi.Cinnamon;
const Applet = imports.ui.applet;
const Main = imports.ui.main;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;
const GLib = imports.gi.GLib;

function MyApplet(metadata,orientation, panel_height) {
    this._init(metadata,orientation, panel_height);
}

MyApplet.prototype = {
    __proto__: Applet.IconApplet.prototype,

    _init: function(metadata,orientation, panel_height) {       
        Applet.IconApplet.prototype._init.call(this, orientation, panel_height);

        try {
            this.set_applet_icon_symbolic_name("document-save");
            this.set_applet_tooltip(_("download wallpaper for web"));
            this.metadata=metadata
	    this.orientation=orientation
	    //读取配置文件
	    this.menuManager = new PopupMenu.PopupMenuManager(this);
	    this.menu = new Applet.AppletPopupMenu(this, this.orientation);
            this.menuManager.addMenu(this.menu);
	    this.UpdateMenu()

	}
        catch (e) {
	   global.logError(e);
        }

    },

    LoadConf: function(){
	//装载配置

	try{
	    this.conf=new GLib.KeyFile()
	    this.conf.load_from_file(this.metadata.path+"/wallpaper.conf", GLib.KeyFileFlags.NONE)
	    this.wallpaperlist=this.conf.get_groups()[0]
	    let fileContent = Cinnamon.get_file_contents_utf8_sync(this.metadata.path+"/save_path.json");
	    this.save_path=eval('('+fileContent+')').save_path
	}catch(e){
	    global.logError(e);
	}
    },

    UpdateMenu: function(){
	this.LoadConf()	
	//创建菜单
	this.menu.removeAll()
	for(let i in this.wallpaperlist){
	    Name=this.wallpaperlist[i]
	    this.menu.addAction(_(Name),Lang.bind(this,this._item_clicked));
	}
	this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
	this.menu.addAction(_("Settings"),Lang.bind(this,this._settings_clicked));  

    },

    _settings_clicked: function(event){
	//wallpaper today 选项
	cmd="python "+this.metadata.path+"/setting.py"
	res=GLib.spawn_command_line_async(cmd)

    },
    _item_clicked: function(event){
	//获取菜单文本
	try{
	    Id=event.get_source().get_children()[0].get_text()
	    cmd="python "+this.metadata.path+"/wallpaper_me.py";
	    cmd+=" "+Id.replace('"','\\"')	    
	    
	    res=GLib.spawn_command_line_async(cmd)

        }catch(e){
	    global.logError(cmd);
	}
    },
    on_applet_clicked: function(event) {
	this.UpdateMenu()	
        this.menu.toggle();        
    },
        
};

function main(metadata, orientation, panel_height) {  
    let myApplet = new MyApplet(metadata,orientation, panel_height);
    return myApplet;      
}
