#coding=utf8
#python 2.7

"""
脚本参数
[wallpaper_name] in wallpaper.conf
"""

#操作网络需要
import urllib
#正则表达式需要
import re
#调用系统命令需要
import os
#获取脚本参数
import sys
import json
import ConfigParser

#-------------------------------------------------------------------------------
def SetWallpaper(fname, name="",style="stretched"):
    # 设置壁纸
    # 适用于gnome 3,也许适用于gnome 2
    os.system('gsettings set org.gnome.desktop.background picture-uri "file://'+fname+'"')
    #设置壁纸样式
    # Possible values: centered, none, scaled, spanned, stretched, wallpaper, zoom

    cmd = 'gsettings set org.gnome.desktop.background picture-options '+style
    os.system(cmd)
    os.system('notify-send "'+name+'今日壁纸下载完成."')
    return
#-------------------------------------------------------------------------------

script_path = os.path.dirname(sys.argv[0])
if script_path == "":
    script_path = "."

try:
    #读取save_path
    with file(script_path+"/save_path.json", 'r') as f:
        f_json = json.load(f)
        
    save_path = f_json['save_path'].encode('utf-8')
    picture_option = f_json['picture_option'].encode("utf-8")

    #读取wallpaper.conf
    conf = ConfigParser.ConfigParser()
    conf.read(script_path+"/wallpaper.conf")
    name = sys.argv[1]
    url = conf.get(name, "url")
    regx_checker = conf.get(name, "checker")

except Exception,e:
    os.system('notify-send "E:'+str(e)+'"')
    exit()

#os.system('notify-send "1'+save_path+'"')
#os.system('notify-send "2'+name+'"')
#os.system('notify-send "3'+url+'"')
#os.system('notify-send "4'+regx_checker+'"')

#打开链接
try:
    html = urllib.urlopen(url).read()
except:
    os.system('notify-send "无法连接到'+name+'网站"')
    exit()

#使用正则表达式寻找壁纸地址,将壁纸地址命名为 link, 壁纸名称为 pic
try:
    checker=re.compile(regx_checker)
    info=checker.search(html).groupdict()
except:
    os.system('notify-send "'+name+'无今日壁纸."')
    exit()


#检测壁纸是否存已经存在,若存在则直接设置，否则下载
fname=save_path+info['pic']
if os.path.exists(fname):
    os.system('notify-send "'+name+'今日壁纸已存在."')
    #设置壁纸
    SetWallpaper(fname,name,picture_option)
    exit()

#下载壁纸
try:
    link=info['link']
    picdata=urllib.urlopen(link).read()
except:
    try:
        link=url+'/'+info['link']
        picdata=urllib.urlopen(link).read()
    except:
        os.system('notify-send url错误!')
        exit()

#保存壁纸到fname,fname咱们在前面定义了
f=file(fname,'w')
f.write(picdata)
f.close()

#设置壁纸
SetWallpaper(fname,name,picture_option)
